/*
	TELENET
	THE GRAIL HUNTER / Tokyo Twilight Busters
	for LSI-C(86)
*/
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>

void main( int ac, char **av )
{
	FILE			*in;
	FILE			*out;
	unsigned char	*buf;
	unsigned char	*filebuf;
	unsigned long	file_ed = 0;
	unsigned int	file_count = 0;
	unsigned long	header_size = 0;
	unsigned long	header_filest = 0;
	unsigned long	header_fileed = 0;
	unsigned long	header_filesize = 0;
	unsigned long	prev;
	char			out_filename[256];
	char			filename[13];
	int				i = 0;
	unsigned long	file_tbl[0x100];

	printf( "TELENET FMU Divider 100215 (c)KUROHANE Works\n" );

	if( ac == 1 )
	{
		printf( "usage: FMUDIV <filename> <filename_prefix> <dest_dir>\n" );
		return;
	}

	in = fopen( av[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", av[1] );
		return;
	}

	printf( "filename: %s\n", av[1] );

	/* filesize */
	fseek( in, 0, SEEK_END );
	file_ed = ftell( in );
	fseek( in, 0, SEEK_SET );
	printf( "file_size: %lu bytes\n", file_ed );

	/* header_size */
	buf = ( unsigned char * )calloc( 1, 2 );
	fread( buf, 2, 1, in );
	header_size = *( unsigned int *)( buf ) * 8;
	free( buf );

	/* Read Header */
	buf = ( unsigned char * )calloc( 1, header_size );
	fread( buf, header_size, 1, in );

	/* file_tbl */
	memset( file_tbl, 0, sizeof( file_tbl ));
	for( i = 0; i < header_size; i += 8 )
	{
		unsigned long	tmp;

		tmp = *( unsigned long *)( buf + i );

		if( i == 0 )
		{
			file_tbl[file_count] = tmp;
			prev = tmp;
		} else {
			if( tmp > prev )
			{
				file_tbl[file_count] = tmp;
				prev = tmp;
			} else {
				file_tbl[file_count] = 0;
			}
		}
		file_count++;
	}
	file_tbl[file_count] = file_ed;

	printf( "file_count: %d\n", file_count );
	printf( "\n" );

	for( i = 0; i != file_count; i++ )
	{
		header_filest = file_tbl[i];
		if( header_filest == 0 ) continue;

		header_fileed = file_tbl[i+1];
		header_filesize = header_fileed - header_filest;

		switch( ac )
		{
			case 2:
				sprintf( out_filename, "BGM_%02d.BIN", i );
				sprintf( filename, "BGM_%02d.BIN", i );
				break;
			case 3:
				sprintf( out_filename, "%s_%02d.BIN", av[2], i );
				sprintf( filename, "%s_%02d.BIN", av[2], i );
				break;
			case 4:
				sprintf( out_filename, "%s%s_%02d.BIN", av[3], av[2], i );
				sprintf( filename, "%s_%02d.BIN", av[2], i );
				break;
		}

		printf( "%s %04lX-%04lX (%lu)\n",
			filename,
			header_filest,
			header_fileed,
			header_filesize
		);

		out = fopen( out_filename, "wb+" );
		if( out == NULL )
		{
			printf( "error: can't write %s\n", filename );
			goto end;
		}

		filebuf = ( unsigned char * )calloc( 1, header_filesize );

		fseek( in, header_filest, SEEK_SET );
		fread( filebuf, header_filesize, 1, in );
		fwrite( filebuf, header_filesize, 1, out );
		fclose( out );

		free( filebuf );
	}

	printf( "\n" );
	printf( "complete.\n" );
end:;
	free( buf );
	fclose( in );

	return;
}
